/*
* MATLAB Compiler: 4.6 (R2007a)
* Date: Wed Feb 27 19:41:48 2008
* Arguments: "-B" "macro_default" "-W"
* "dotnet:ClearPictureElar,ClearPictureElarclass,1.1,private" "-d"
* "C:\Elar\NetWrapper\ClearPictureElar\ClearPictureElar\src" "-T" "link:lib" "-v"
* "class{ClearPictureElarclass:C:\Elar\NetWrapper\ClearPictureElar\clear_image_elar.m,C:\E
* lar\NetWrapper\ClearPictureElar\clear_picture_elar.m}" 
*/

using System;
using System.Reflection;

using MathWorks.MATLAB.NET.Arrays;
using MathWorks.MATLAB.NET.Utility;


[assembly: System.Reflection.AssemblyVersion("1.1.*")]
#if SHARED
[assembly: System.Reflection.AssemblyKeyFile(@"")]
#endif

namespace ClearPictureElar
{
  /// <summary>
  /// The ClearPictureElarclass class provides a CLS compliant interface to the
  /// M-functions contained in the files:
  /// <newpara></newpara>
  /// C:\Elar\NetWrapper\ClearPictureElar\clear_image_elar.m
  /// <newpara></newpara>
  /// C:\Elar\NetWrapper\ClearPictureElar\clear_picture_elar.m
  /// <newpara></newpara>
  /// matlabrc.m
  /// <newpara></newpara>
  /// dirname.m
  /// <newpara></newpara>
  /// deployprint.m
  /// <newpara></newpara>
  /// printdlg.m
  /// </summary>
  /// <remarks>
  /// @Version 1.1
  /// </remarks>
  public class ClearPictureElarclass : IDisposable
    {
      #region Constructors

      /// <summary internal= "true">
      /// The static constructor instantiates and initializes the MATLAB Common Runtime
      /// instance.
      /// </summary>
      static ClearPictureElarclass()
        {
          Assembly assembly= Assembly.GetExecutingAssembly();

          string ctfFilePath= assembly.Location;

          int lastDelimeter= ctfFilePath.LastIndexOf(@"\");

          ctfFilePath= ctfFilePath.Remove(lastDelimeter, (ctfFilePath.Length - lastDelimeter));

          if (MWMCR.InitializeApplication(new string[]{}))
            {
              mcr= new MWMCR(MCRComponentState.MCC_ClearPictureElar_name_data,
                             MCRComponentState.MCC_ClearPictureElar_root_data,
                             MCRComponentState.MCC_ClearPictureElar_public_data,
                             MCRComponentState.MCC_ClearPictureElar_session_data,
                             MCRComponentState.MCC_ClearPictureElar_matlabpath_data,
                             MCRComponentState.MCC_ClearPictureElar_classpath_data,
                             MCRComponentState.MCC_ClearPictureElar_libpath_data,
                             MCRComponentState.MCC_ClearPictureElar_mcr_application_options,
                             MCRComponentState.MCC_ClearPictureElar_mcr_runtime_options,
                             MCRComponentState.MCC_ClearPictureElar_mcr_pref_dir,
                             MCRComponentState.MCC_ClearPictureElar_set_warning_state,
                             ctfFilePath, true);
            }
        }


      /// <summary>
      /// Constructs a new instance of the ClearPictureElarclass class.
      /// </summary>
      public ClearPictureElarclass()
        {
        }


      #endregion Constructors

      #region Finalize

      /// <summary internal= "true">
      /// Class destructor called by the CLR garbage collector.
      /// </summary>
      ~ClearPictureElarclass()
        {
          Dispose(false);
        }


      /// <summary>
      /// Frees the native resources associated with this object
      /// </summary>
      public void Dispose()
        {
          Dispose(true);

          GC.SuppressFinalize(this);
        }


      /// <summary internal= "true">
      /// Internal dispose function
      /// </summary>
      protected virtual void Dispose(bool disposing)
        {
          if (!disposed)
            {
              disposed= true;

              if (disposing)
                {
                  // Free managed resources;
                }

              // Free native resources
            }
        }


      #endregion Finalize

      #region Methods

      /// <summary>
      /// Provides a void output, 0-input interface to the clear_image_elar M-function.
      /// </summary>
      /// <remarks>
      /// M-Documentation:
      /// name='test7';
      /// n_erode_hor=10;
      /// n_reconst_hor=45;
      /// n_reconst_ver=1;
      /// n_kind_fill=1;
      /// n_filterwindowsize=10;
      /// gamma=15;
      /// </remarks>
      ///
      public void clear_image_elar()
        {
          mcr.EvaluateFunction(0, "clear_image_elar");
        }


      /// <summary>
      /// Provides a void output, 1-input interface to the clear_image_elar M-function.
      /// </summary>
      /// <remarks>
      /// M-Documentation:
      /// name='test7';
      /// n_erode_hor=10;
      /// n_reconst_hor=45;
      /// n_reconst_ver=1;
      /// n_kind_fill=1;
      /// n_filterwindowsize=10;
      /// gamma=15;
      /// </remarks>
      /// <param name="varargin">Array of MWArrays representing the input arguments 1
      /// through varargin.length</param>
      ///
      public void clear_image_elar(params MWArray[] varargin)
        {
          mcr.EvaluateFunction(0, "clear_image_elar", varargin);
        }


      /// <summary>
      /// Provides the standard 0-input interface to the clear_image_elar M-function.
      /// </summary>
      /// <remarks>
      /// M-Documentation:
      /// name='test7';
      /// n_erode_hor=10;
      /// n_reconst_hor=45;
      /// n_reconst_ver=1;
      /// n_kind_fill=1;
      /// n_filterwindowsize=10;
      /// gamma=15;
      /// </remarks>
      /// <param name="numArgsOut">The number of output arguments to return.</param>
      /// <returns>An Array of length "numArgsOut" containing the output
      /// arguments.</returns>
      ///
      public MWArray[] clear_image_elar(int numArgsOut)
        {
          return mcr.EvaluateFunction(numArgsOut, "clear_image_elar");
        }


      /// <summary>
      /// Provides the standard 1-input interface to the clear_image_elar M-function.
      /// </summary>
      /// <remarks>
      /// M-Documentation:
      /// name='test7';
      /// n_erode_hor=10;
      /// n_reconst_hor=45;
      /// n_reconst_ver=1;
      /// n_kind_fill=1;
      /// n_filterwindowsize=10;
      /// gamma=15;
      /// </remarks>
      /// <param name="numArgsOut">The number of output arguments to return.</param>
      /// <param name="varargin">Array of MWArrays representing the input arguments 1
      /// through varargin.length</param>
      /// <returns>An Array of length "numArgsOut" containing the output
      /// arguments.</returns>
      ///
      public MWArray[] clear_image_elar(int numArgsOut, params MWArray[] varargin)
        {
          return mcr.EvaluateFunction(numArgsOut, "clear_image_elar", varargin);
        }


      /// <summary>
      /// Provides a void output, 0-input interface to the clear_picture_elar M-function.
      /// </summary>
      /// <remarks>
      /// </remarks>
      ///
      public void clear_picture_elar()
        {
          mcr.EvaluateFunction(0, "clear_picture_elar");
        }


      /// <summary>
      /// Provides a void output, 1-input interface to the clear_picture_elar M-function.
      /// </summary>
      /// <remarks>
      /// </remarks>
      /// <param name="filename">Input argument #1</param>
      ///
      public void clear_picture_elar(MWArray filename)
        {
          mcr.EvaluateFunction(0, "clear_picture_elar", filename);
        }


      /// <summary>
      /// Provides the standard 0-input interface to the clear_picture_elar M-function.
      /// </summary>
      /// <remarks>
      /// </remarks>
      /// <param name="numArgsOut">The number of output arguments to return.</param>
      /// <returns>An Array of length "numArgsOut" containing the output
      /// arguments.</returns>
      ///
      public MWArray[] clear_picture_elar(int numArgsOut)
        {
          return mcr.EvaluateFunction(numArgsOut, "clear_picture_elar");
        }


      /// <summary>
      /// Provides the standard 1-input interface to the clear_picture_elar M-function.
      /// </summary>
      /// <remarks>
      /// </remarks>
      /// <param name="numArgsOut">The number of output arguments to return.</param>
      /// <param name="filename">Input argument #1</param>
      /// <returns>An Array of length "numArgsOut" containing the output
      /// arguments.</returns>
      ///
      public MWArray[] clear_picture_elar(int numArgsOut, MWArray filename)
        {
          return mcr.EvaluateFunction(numArgsOut, "clear_picture_elar", filename);
        }


      
      #endregion Methods

      #region Class Members

      private static MWMCR mcr= null;

      private bool disposed= false;

      #endregion Class Members
    }
}
